# coding: utf-8

"""
    aind-session-json-service

     ## aind-session-json-service  Run metadata mapper to create a session metadata  

    The version of the OpenAPI document: 0.1.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from aind_session_json_service_async_client.models.fov_coordinate_ml import FovCoordinateMl
from aind_session_json_service_async_client.models.input_source import InputSource
from aind_session_json_service_async_client.models.output_directory import OutputDirectory
from aind_session_json_service_async_client.models.user_settings_config_file import UserSettingsConfigFile
from typing import Optional, Set
from typing_extensions import Self

class JobSettings(BaseModel):
    """
    Data that needs to be input by user. Can be pulled from env vars with BERGAMO prefix or set explicitly.
    """ # noqa: E501
    job_settings_name: Optional[StrictStr] = 'Bergamo'
    input_source: Optional[InputSource] = None
    output_directory: Optional[OutputDirectory] = None
    user_settings_config_file: Optional[UserSettingsConfigFile] = None
    experimenter_full_name: List[StrictStr]
    subject_id: StrictStr
    imaging_laser_wavelength: StrictInt
    fov_imaging_depth: StrictInt
    fov_targeted_structure: StrictStr
    notes: Optional[StrictStr]
    mouse_platform_name: Optional[StrictStr] = 'Standard Mouse Tube'
    active_mouse_platform: Optional[StrictBool] = False
    session_type: Optional[StrictStr] = 'BCI'
    iacuc_protocol: Optional[StrictStr] = '2109'
    rig_id: Optional[StrictStr] = '442 Bergamo 2p photostim'
    behavior_camera_names: Optional[List[StrictStr]] = None
    ch1_filter_names: Optional[List[StrictStr]] = None
    ch1_detector_name: Optional[StrictStr] = 'Green PMT'
    ch1_daq_name: Optional[StrictStr] = 'PXI'
    ch2_filter_names: Optional[List[StrictStr]] = None
    ch2_detector_name: Optional[StrictStr] = 'Red PMT'
    ch2_daq_name: Optional[StrictStr] = 'PXI'
    imaging_laser_name: Optional[StrictStr] = 'Chameleon Laser'
    photostim_laser_name: Optional[StrictStr] = 'Monaco Laser'
    stimulus_device_names: Optional[List[StrictStr]] = None
    photostim_laser_wavelength: Optional[StrictInt] = 1040
    fov_coordinate_ml: Optional[FovCoordinateMl] = None
    fov_coordinate_ap: Optional[Union[StrictFloat, StrictInt]] = 1.5
    fov_reference: Optional[StrictStr] = 'Bregma'
    starting_lickport_position: Optional[List[Union[StrictFloat, StrictInt]]] = None
    behavior_task_name: Optional[StrictStr] = 'single neuron BCI conditioning'
    hit_rate_trials_0_10: Optional[Union[StrictFloat, StrictInt]] = None
    hit_rate_trials_20_40: Optional[Union[StrictFloat, StrictInt]] = None
    total_hits: Optional[Union[StrictFloat, StrictInt]] = None
    average_hit_rate: Optional[Union[StrictFloat, StrictInt]] = None
    trial_num: Optional[Union[StrictFloat, StrictInt]] = None
    timezone: Optional[StrictStr] = 'US/Pacific'
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["job_settings_name", "input_source", "output_directory", "user_settings_config_file", "experimenter_full_name", "subject_id", "imaging_laser_wavelength", "fov_imaging_depth", "fov_targeted_structure", "notes", "mouse_platform_name", "active_mouse_platform", "session_type", "iacuc_protocol", "rig_id", "behavior_camera_names", "ch1_filter_names", "ch1_detector_name", "ch1_daq_name", "ch2_filter_names", "ch2_detector_name", "ch2_daq_name", "imaging_laser_name", "photostim_laser_name", "stimulus_device_names", "photostim_laser_wavelength", "fov_coordinate_ml", "fov_coordinate_ap", "fov_reference", "starting_lickport_position", "behavior_task_name", "hit_rate_trials_0_10", "hit_rate_trials_20_40", "total_hits", "average_hit_rate", "trial_num", "timezone"]

    @field_validator('job_settings_name')
    def job_settings_name_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Bergamo']):
            raise ValueError("must be one of enum values ('Bergamo')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of JobSettings from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of input_source
        if self.input_source:
            _dict['input_source'] = self.input_source.to_dict()
        # override the default output from pydantic by calling `to_dict()` of output_directory
        if self.output_directory:
            _dict['output_directory'] = self.output_directory.to_dict()
        # override the default output from pydantic by calling `to_dict()` of user_settings_config_file
        if self.user_settings_config_file:
            _dict['user_settings_config_file'] = self.user_settings_config_file.to_dict()
        # override the default output from pydantic by calling `to_dict()` of fov_coordinate_ml
        if self.fov_coordinate_ml:
            _dict['fov_coordinate_ml'] = self.fov_coordinate_ml.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        # set to None if input_source (nullable) is None
        # and model_fields_set contains the field
        if self.input_source is None and "input_source" in self.model_fields_set:
            _dict['input_source'] = None

        # set to None if output_directory (nullable) is None
        # and model_fields_set contains the field
        if self.output_directory is None and "output_directory" in self.model_fields_set:
            _dict['output_directory'] = None

        # set to None if user_settings_config_file (nullable) is None
        # and model_fields_set contains the field
        if self.user_settings_config_file is None and "user_settings_config_file" in self.model_fields_set:
            _dict['user_settings_config_file'] = None

        # set to None if notes (nullable) is None
        # and model_fields_set contains the field
        if self.notes is None and "notes" in self.model_fields_set:
            _dict['notes'] = None

        # set to None if hit_rate_trials_0_10 (nullable) is None
        # and model_fields_set contains the field
        if self.hit_rate_trials_0_10 is None and "hit_rate_trials_0_10" in self.model_fields_set:
            _dict['hit_rate_trials_0_10'] = None

        # set to None if hit_rate_trials_20_40 (nullable) is None
        # and model_fields_set contains the field
        if self.hit_rate_trials_20_40 is None and "hit_rate_trials_20_40" in self.model_fields_set:
            _dict['hit_rate_trials_20_40'] = None

        # set to None if total_hits (nullable) is None
        # and model_fields_set contains the field
        if self.total_hits is None and "total_hits" in self.model_fields_set:
            _dict['total_hits'] = None

        # set to None if average_hit_rate (nullable) is None
        # and model_fields_set contains the field
        if self.average_hit_rate is None and "average_hit_rate" in self.model_fields_set:
            _dict['average_hit_rate'] = None

        # set to None if trial_num (nullable) is None
        # and model_fields_set contains the field
        if self.trial_num is None and "trial_num" in self.model_fields_set:
            _dict['trial_num'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of JobSettings from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "job_settings_name": obj.get("job_settings_name") if obj.get("job_settings_name") is not None else 'Bergamo',
            "input_source": InputSource.from_dict(obj["input_source"]) if obj.get("input_source") is not None else None,
            "output_directory": OutputDirectory.from_dict(obj["output_directory"]) if obj.get("output_directory") is not None else None,
            "user_settings_config_file": UserSettingsConfigFile.from_dict(obj["user_settings_config_file"]) if obj.get("user_settings_config_file") is not None else None,
            "experimenter_full_name": obj.get("experimenter_full_name"),
            "subject_id": obj.get("subject_id"),
            "imaging_laser_wavelength": obj.get("imaging_laser_wavelength"),
            "fov_imaging_depth": obj.get("fov_imaging_depth"),
            "fov_targeted_structure": obj.get("fov_targeted_structure"),
            "notes": obj.get("notes"),
            "mouse_platform_name": obj.get("mouse_platform_name") if obj.get("mouse_platform_name") is not None else 'Standard Mouse Tube',
            "active_mouse_platform": obj.get("active_mouse_platform") if obj.get("active_mouse_platform") is not None else False,
            "session_type": obj.get("session_type") if obj.get("session_type") is not None else 'BCI',
            "iacuc_protocol": obj.get("iacuc_protocol") if obj.get("iacuc_protocol") is not None else '2109',
            "rig_id": obj.get("rig_id") if obj.get("rig_id") is not None else '442 Bergamo 2p photostim',
            "behavior_camera_names": obj.get("behavior_camera_names"),
            "ch1_filter_names": obj.get("ch1_filter_names"),
            "ch1_detector_name": obj.get("ch1_detector_name") if obj.get("ch1_detector_name") is not None else 'Green PMT',
            "ch1_daq_name": obj.get("ch1_daq_name") if obj.get("ch1_daq_name") is not None else 'PXI',
            "ch2_filter_names": obj.get("ch2_filter_names"),
            "ch2_detector_name": obj.get("ch2_detector_name") if obj.get("ch2_detector_name") is not None else 'Red PMT',
            "ch2_daq_name": obj.get("ch2_daq_name") if obj.get("ch2_daq_name") is not None else 'PXI',
            "imaging_laser_name": obj.get("imaging_laser_name") if obj.get("imaging_laser_name") is not None else 'Chameleon Laser',
            "photostim_laser_name": obj.get("photostim_laser_name") if obj.get("photostim_laser_name") is not None else 'Monaco Laser',
            "stimulus_device_names": obj.get("stimulus_device_names"),
            "photostim_laser_wavelength": obj.get("photostim_laser_wavelength") if obj.get("photostim_laser_wavelength") is not None else 1040,
            "fov_coordinate_ml": FovCoordinateMl.from_dict(obj["fov_coordinate_ml"]) if obj.get("fov_coordinate_ml") is not None else None,
            "fov_coordinate_ap": obj.get("fov_coordinate_ap") if obj.get("fov_coordinate_ap") is not None else 1.5,
            "fov_reference": obj.get("fov_reference") if obj.get("fov_reference") is not None else 'Bregma',
            "starting_lickport_position": obj.get("starting_lickport_position"),
            "behavior_task_name": obj.get("behavior_task_name") if obj.get("behavior_task_name") is not None else 'single neuron BCI conditioning',
            "hit_rate_trials_0_10": obj.get("hit_rate_trials_0_10"),
            "hit_rate_trials_20_40": obj.get("hit_rate_trials_20_40"),
            "total_hits": obj.get("total_hits"),
            "average_hit_rate": obj.get("average_hit_rate"),
            "trial_num": obj.get("trial_num"),
            "timezone": obj.get("timezone") if obj.get("timezone") is not None else 'US/Pacific'
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


